Summary: The Link Status Monitor
Name: lsm
Version: 0.64
Release: 1%{?dist}
License: GPLv2
Group: System Environment/Daemons
URL: http://lsm.foobar.fi/
Source: %{name}-%{version}.tar.gz
Requires(post): chkconfig
Requires(postun): /sbin/service
Requires(preun): /sbin/service
Requires(preun): chkconfig
Requires: mailx
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

%description
Lsm is the link status monitor.

Lsm can ping multiple targets and when up or down event happens
it will execute user configured external script so it can be used
as poor man's routing protocol.

%prep
%setup -q -n %{name}

%build
%{__make} CFLAGS="$RPM_OPT_FLAGS" %{?_smp_mflags}

%install
%{__rm} -rf $RPM_BUILD_ROOT

%{__mkdir_p} $RPM_BUILD_ROOT%{_sysconfdir}/lsm
%{__mkdir_p} $RPM_BUILD_ROOT%{_initrddir}
%{__mkdir_p} $RPM_BUILD_ROOT%{_sbindir}
%{__mkdir_p} $RPM_BUILD_ROOT%{_datadir}/lsm

%{__install} -m0755 lsm $RPM_BUILD_ROOT%{_sbindir}
%{__install} -m0644 lsm.conf $RPM_BUILD_ROOT%{_sysconfdir}/lsm
%{__install} -m0755 default_script $RPM_BUILD_ROOT%{_datadir}/lsm
%{__install} -m0755 lsm.init $RPM_BUILD_ROOT%{_initrddir}/lsm

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add lsm

%preun
if [ $1 -eq 0 ]; then
    /sbin/service lsm stop >/dev/null 2>&1 || :
    /sbin/chkconfig --del lsm
fi

%postun
if [ $1 -ge 1 ]; then
    /sbin/service lsm condrestart >/dev/null 2>&1
fi


%files
%defattr(-,root,root)
%doc README lsm.conf.sample default_script.sample
%{_initrddir}/%{name}
%dir %{_sysconfdir}/lsm
%config(noreplace) %{_sysconfdir}/lsm/lsm.conf
%{_datadir}/lsm/default_script
%{_sbindir}/lsm

%changelog
* Fri Dec 31 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.64-1
- fill up target struct src address for ping also
  do it at startup (should this be done every time we send ping packet?)

* Fri Dec 31 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.63-1
- Added src ip to script parameters
  src ip paramater is the last one so that every single old config
  doesn't have to be rewritten.

* Fri Dec 10 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.62-1
- check for valid ip-address in checkip parameter

* Fri Dec 10 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.61-1
- changed lsm.c init_config to init_config_data
- added init_config to config.c which is then called before read_config
- added a warning when checkip is not set

* Sat Oct  9 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.60-1
- fix recursive read_config use. set default values only once.
- use cfg.debug only after config is read
- added default_script.sample

* Mon Sep 27 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.59-1
- remember connection statuses after config reload

* Mon Sep 27 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.58-1
- reopen_on_enodev support. set this to 1 so lsm will try to reopen ping
  device when it encounters ENODEV error when sending ping packet

* Sun Sep 19 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.57-1
- added defaults status to give initial assumption of the connection status
- added config status for connections. is it assumed down = 0 or up = 1
  at lsm start

* Sat Sep 18 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.56-1
- fixed rpmlint-v0.91 warnings.

* Sat Apr 24 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.53-1
- added error checking to ftruncate and write so that mock build doesn't
  complain
- introduced timeval_diff_cmp function as it seems quite problematic to
  really compare times in usec since epoch using integer values.
  especially 32bit systems were seeing 99% CPU loads because of this.

* Thu Apr 22 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.52-1
- initialize all struct timeval structures to tv_sec = 0 and tv_usec = 0
- added use of error flag to arping sending

* Fri Mar  5 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.51-1
- fix avg rtt calculation comment
- show in the default mail template avg rtt unit [usec]
- in syslog avg rtt is reported in [msec] as of v0.50 like ping does

* Fri Mar  5 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.50-1
- report rtt with three decimals accuracy

* Thu Mar  4 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.49-1
- count average rtt in milliseconds not in microseconds

* Thu Mar  4 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.48-1
- don't count timeouted late replies in cons rcvd

* Thu Mar  4 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.47-1
- added some missing fields to lsm.init

* Thu Mar  4 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.46-1
- dump all statuses only if requested by SIGUSR1
- otherwise dump only connection status data of connection whose status changed

* Wed Mar  3 2010 Mika Ilmaranta <ilmis@nullnet.fi> - 0.45-1
- use LOG_PID openlog option

* Thu Dec 17 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.44-1
- added some parameter sanity checking. if max_packet_loss <= min_packet_loss then there can be a flip-flop effect
  and many many and still a few reports mailed to warn_email address.

* Mon Nov  9 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.43-1
- convert all tabs to spaces before processing config line

* Sun Sep 27 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.42-1
- changed action script to event script to follow suite with config

* Sun Sep 27 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.41-1
- added action_script_check() to check for valid action script

* Wed Sep  2 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.40-1
- lseek to start of pid file and ftruncate it to zero size before writing
  our new pid. this prevents us having two pids in the file if previous
  lsm crashed or exited and did not remove the file (fcntl lock is cleared
  by kernel as process dies "prematurely").

* Mon Jun 29 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.39-1
- set close on exec flag for fds and sockets
- call closelog() within forked child before exec

* Thu Jun 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.38-1
- require mailx for /bin/mail as default_script uses it

* Thu Jun 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.37-1
- when dumping config log also group's warn_email and logic
- set last previous last group members next to the new last member

* Thu Jun 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.36-1
- apply sane defaults to group parameters

* Thu Jun  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.35-1
- only log sendto errors with debug >= 9

* Thu Jun  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.34-1
- better sendto error ignore fix
- changed syslog calls for Mandrake

* Thu Jun  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.33-1
- ping_send: don't care about sendto errors

* Wed Apr 29 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.32-1
- split long debug explanation line in lsm.conf

* Wed Apr 29 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.31-1
- left only defaults in lsm.conf and moved examples to
  lsm.conf.sample

* Tue Apr 28 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.30-1
- timeval_diff calculation order change to prevent
  long overflow. nobody has encoutered that but just to be
  sure
- use default ttl=0 which uses system default ttl

* Sat Apr 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.29-1
- Added decision making section to README written by Dean Takemori
  he suggested to include it in lsm.conf but I thought it was
  long enough already

* Sat Apr 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.28-1
- Tom Eastep's fix for last_sent_time initialization
- added time stamp to default_script mail body

* Fri Apr 10 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.27-1
- added checks for missing group members

* Fri Apr 10 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.26-1
- added connection grouping

* Thu Apr  9 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.25-1
- gettimeofday failure patch from Dean Takemori

* Sun Apr  5 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.24-1
- add support for SIGHUP to reload config

* Tue Mar 24 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.23-1
- changed ping packets to use own socket for each target.
  looks like setsockopt SO_BINDTOINTERFACE is not reversible and
  according to documentation I found using it multiple times
  may lead to unpredicted results due to kernel caching.

* Tue Mar 24 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.22-1
- changed indentation to tabs

* Mon Mar 16 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.21-1
- added LSM: to default_script mail subject

* Tue Mar 10 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.20-1
- handle ENODEV as if the ping packet was sent, but do barf to syslog
  about it. this will eventually cause a down event. added
  an error flag which is set if sendto returns with value < 0.
- dump connection statuses to syslog when up/down-event happens.
- moved status dump's "header" -line above the pkt status bits.
- added error flag dumping.

* Fri Mar  6 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.19-1
- fix pid file write order

* Thu Mar  5 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.18-1
- added pid file handling

* Thu Mar  5 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.17-1
- rebuild because of mystical i386 build problems

* Wed Mar  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.16-1
- pass only LANG, PATH and TERM environment variables to
  scripts

* Wed Mar  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.15-1
- fixed all rpmlint errors reported in binary pkg
  which means that default_script is moved to /usr/share/lsm

* Wed Mar  4 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.14-1
- added ipv6 support to TODO list
- fixed rpmlint errors in lsm.spec

* Tue Feb 24 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.13-1
- typos: lisence -> license
- mention SIGUSR1 behaviour in README
- added a check for ENODEV for ping packets

* Fri Feb 20 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.12-1
- don't define device= in defaults

* Wed Feb 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.11-1
- if device is not specified return NA

* Wed Feb 18 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.10-1
- added device to script parameters
- first try on binding ping packets to device

* Thu Feb 12 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.9-1
- fixed rtt comments in default_script

* Thu Feb 12 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.8-1
- init script reload fix

* Sat Feb  7 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.7-1
- fixed typos
- init script reload was missing

* Sun Feb  1 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.6-1
- fixed comments and readme to correspond current status

* Sun Feb  1 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.6-1
- now each target has its own ttl setting

* Sat Jan 31 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-8
- check for no targets specified in conf

* Sat Jan 31 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-7
- all except DEBUG is now syslogged

* Sat Jan 31 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-4
- added ttl setting handling for ping packets. currently all
  ping monitored links share a common ttl value which is
  taken from the first config entry's ttl value.
- when SIGUSR1 is received lsm dumps current packet info to
  syslog ...

* Sat Jan 31 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-3
- changed avg rtt calculation so that only replied packets'
  rtt is counted

* Sat Jan 31 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-2
- Added a ping reply packet min size check

* Fri Jan 30 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.5-1
- started adding support for arp check which is actually
  using arp packets rather than ping packets in case
  your gw administrators have blocked ping

* Thu Jan 29 2009 Mika Ilmaranta <ilmis@nullnet.fi> - 0.4-1
- Initial build

#EOF
